Hex Artifact Content

Artifact aadeaa622b049a792162ce1900656f5e9d64ef37:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 49  2...exit 1.fi..I
00f0: 54 43 4c 56 45 52 53 3d 22 33 2e 34 22 0a 49 54  TCLVERS="3.4".IT
0100: 43 4c 56 45 52 53 45 58 54 52 41 3d 22 62 31 22  CLVERSEXTRA="b1"
0110: 0a 53 52 43 3d 22 73 72 63 2f 69 74 63 6c 2d 24  .SRC="src/itcl-$
0120: 7b 49 54 43 4c 56 45 52 53 7d 2e 74 61 72 2e 67  {ITCLVERS}.tar.g
0130: 7a 22 0a 53 52 43 55 52 4c 3d 22 68 74 74 70 3a  z".SRCURL="http:
0140: 2f 2f 73 6f 75 72 63 65 66 6f 72 67 65 2e 6e 65  //sourceforge.ne
0150: 74 2f 70 72 6f 6a 65 63 74 73 2f 69 6e 63 72 74  t/projects/incrt
0160: 63 6c 2f 66 69 6c 65 73 2f 25 35 42 49 6e 63 72  cl/files/%5BIncr
0170: 25 32 30 54 63 6c 5f 54 6b 25 35 44 2d 73 6f 75  %20Tcl_Tk%5D-sou
0180: 72 63 65 2f 24 7b 49 54 43 4c 56 45 52 53 7d 2f  rce/${ITCLVERS}/
0190: 69 74 63 6c 24 7b 49 54 43 4c 56 45 52 53 7d 24  itcl${ITCLVERS}$
01a0: 7b 49 54 43 4c 56 45 52 53 45 58 54 52 41 7d 2e  {ITCLVERSEXTRA}.
01b0: 74 61 72 2e 67 7a 2f 64 6f 77 6e 6c 6f 61 64 22  tar.gz/download"
01c0: 0a 42 55 49 4c 44 44 49 52 3d 22 24 28 70 77 64  .BUILDDIR="$(pwd
01d0: 29 2f 62 75 69 6c 64 2f 69 74 63 6c 24 7b 49 54  )/build/itcl${IT
01e0: 43 4c 56 45 52 53 7d 22 0a 4f 55 54 44 49 52 3d  CLVERS}".OUTDIR=
01f0: 22 24 28 70 77 64 29 2f 6f 75 74 22 0a 49 4e 53  "$(pwd)/out".INS
0200: 54 44 49 52 3d 22 24 28 70 77 64 29 2f 69 6e 73  TDIR="$(pwd)/ins
0210: 74 22 0a 65 78 70 6f 72 74 20 49 54 43 4c 56 45  t".export ITCLVE
0220: 52 53 20 53 52 43 20 53 52 43 55 52 4c 20 42 55  RS SRC SRCURL BU
0230: 49 4c 44 44 49 52 20 4f 55 54 44 49 52 20 49 4e  ILDDIR OUTDIR IN
0240: 53 54 44 49 52 0a 0a 72 6d 20 2d 72 66 20 27 62  STDIR..rm -rf 'b
0250: 75 69 6c 64 27 20 27 6f 75 74 27 20 27 69 6e 73  uild' 'out' 'ins
0260: 74 27 0a 6d 6b 64 69 72 20 27 62 75 69 6c 64 27  t'.mkdir 'build'
0270: 20 27 6f 75 74 27 20 27 69 6e 73 74 27 20 7c 7c   'out' 'inst' ||
0280: 20 65 78 69 74 20 31 0a 0a 23 20 44 65 74 65 72   exit 1..# Deter
0290: 6d 69 6e 65 20 69 66 20 49 74 63 6c 20 69 73 20  mine if Itcl is 
02a0: 65 76 65 6e 20 6e 65 65 64 65 64 0a 28 0a 09 54  even needed.(..T
02b0: 43 4c 5f 56 45 52 53 49 4f 4e 3d 22 75 6e 6b 6e  CL_VERSION="unkn
02c0: 6f 77 6e 22 0a 09 69 66 20 5b 20 2d 66 20 22 24  own"..if [ -f "$
02d0: 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d 2f 74  {TCLCONFIGDIR}/t
02e0: 63 6c 43 6f 6e 66 69 67 2e 73 68 22 20 5d 3b 20  clConfig.sh" ]; 
02f0: 74 68 65 6e 0a 09 09 73 6f 75 72 63 65 20 22 24  then...source "$
0300: 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d 2f 74  {TCLCONFIGDIR}/t
0310: 63 6c 43 6f 6e 66 69 67 2e 73 68 22 0a 09 66 69  clConfig.sh"..fi
0320: 0a 0a 09 69 66 20 65 63 68 6f 20 22 24 7b 54 43  ...if echo "${TC
0330: 4c 5f 56 45 52 53 49 4f 4e 7d 22 20 7c 20 67 72  L_VERSION}" | gr
0340: 65 70 20 27 5e 38 5c 2e 5b 34 35 5d 24 27 20 3e  ep '^8\.[45]$' >
0350: 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a  /dev/null; then.
0360: 09 09 23 20 49 74 63 6c 20 69 73 20 72 65 71 75  ..# Itcl is requ
0370: 69 72 65 64 20 66 6f 72 20 54 63 6c 20 38 2e 34  ired for Tcl 8.4
0380: 20 61 6e 64 20 54 63 6c 20 38 2e 35 0a 0a 09 09   and Tcl 8.5....
0390: 65 78 69 74 20 30 0a 09 66 69 0a 0a 09 69 66 20  exit 0..fi...if 
03a0: 5b 20 22 24 7b 54 43 4c 5f 56 45 52 53 49 4f 4e  [ "${TCL_VERSION
03b0: 7d 22 20 3d 20 22 75 6e 6b 6e 6f 77 6e 22 20 5d  }" = "unknown" ]
03c0: 3b 20 74 68 65 6e 0a 09 09 23 20 49 66 20 77 65  ; then...# If we
03d0: 20 64 6f 6e 27 74 20 6b 6e 6f 77 20 77 68 61 74   don't know what
03e0: 20 76 65 72 73 69 6f 6e 20 6f 66 20 54 63 6c 20   version of Tcl 
03f0: 77 65 20 61 72 65 20 62 75 69 6c 64 69 6e 67 2c  we are building,
0400: 20 62 75 69 6c 64 0a 09 09 23 20 49 74 63 6c 20   build...# Itcl 
0410: 6a 75 73 74 20 69 6e 20 63 61 73 65 2e 0a 0a 09  just in case....
0420: 09 65 78 69 74 20 30 0a 09 66 69 0a 0a 09 23 20  .exit 0..fi...# 
0430: 41 6c 6c 20 6f 74 68 65 72 20 76 65 72 73 69 6f  All other versio
0440: 6e 73 20 64 6f 20 6e 6f 74 20 72 65 71 75 69 72  ns do not requir
0450: 65 20 49 74 63 6c 0a 09 65 63 68 6f 20 22 53 6b  e Itcl..echo "Sk
0460: 69 70 70 69 6e 67 20 62 75 69 6c 64 69 6e 67 20  ipping building 
0470: 49 74 63 6c 2c 20 6e 6f 74 20 72 65 71 75 69 72  Itcl, not requir
0480: 65 64 20 66 6f 72 20 24 7b 54 43 4c 5f 56 45 52  ed for ${TCL_VER
0490: 53 49 4f 4e 7d 22 0a 09 65 78 69 74 20 31 0a 29  SION}"..exit 1.)
04a0: 20 7c 7c 20 65 78 69 74 20 30 0a 0a 69 66 20 5b   || exit 0..if [
04b0: 20 21 20 2d 66 20 22 24 7b 53 52 43 7d 22 20 5d   ! -f "${SRC}" ]
04c0: 3b 20 74 68 65 6e 0a 09 6d 6b 64 69 72 20 27 73  ; then..mkdir 's
04d0: 72 63 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32  rc' >/dev/null 2
04e0: 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 0a 09 69 66 20  >/dev/null...if 
04f0: 5b 20 21 20 2d 64 20 27 62 75 69 6c 64 73 72 63  [ ! -d 'buildsrc
0500: 27 20 5d 3b 20 74 68 65 6e 0a 09 09 72 6d 20 2d  ' ]; then...rm -
0510: 66 20 22 24 7b 53 52 43 7d 2e 74 6d 70 22 0a 09  f "${SRC}.tmp"..
0520: 09 77 67 65 74 20 2d 4f 20 22 24 7b 53 52 43 7d  .wget -O "${SRC}
0530: 2e 74 6d 70 22 20 22 24 7b 53 52 43 55 52 4c 7d  .tmp" "${SRCURL}
0540: 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 6d 76  " || exit 1...mv
0550: 20 22 24 7b 53 52 43 7d 2e 74 6d 70 22 20 22 24   "${SRC}.tmp" "$
0560: 7b 53 52 43 7d 22 0a 09 66 69 0a 66 69 0a 0a 28  {SRC}"..fi.fi..(
0570: 0a 09 63 64 20 27 62 75 69 6c 64 27 20 7c 7c 20  ..cd 'build' || 
0580: 65 78 69 74 20 31 0a 0a 09 69 66 20 5b 20 21 20  exit 1...if [ ! 
0590: 2d 64 20 27 2e 2e 2f 62 75 69 6c 64 73 72 63 27  -d '../buildsrc'
05a0: 20 5d 3b 20 74 68 65 6e 0a 09 09 67 7a 69 70 20   ]; then...gzip 
05b0: 2d 64 63 20 22 2e 2e 2f 24 7b 53 52 43 7d 22 20  -dc "../${SRC}" 
05c0: 7c 20 74 61 72 20 2d 78 66 20 2d 0a 09 65 6c 73  | tar -xf -..els
05d0: 65 20 20 20 20 0a 09 09 63 70 20 2d 72 70 20 2e  e    ...cp -rp .
05e0: 2e 2f 62 75 69 6c 64 73 72 63 2f 2a 20 27 2e 2f  ./buildsrc/* './
05f0: 27 0a 09 66 69 0a 0a 09 63 64 20 22 24 7b 42 55  '..fi...cd "${BU
0600: 49 4c 44 44 49 52 7d 22 20 7c 7c 20 65 78 69 74  ILDDIR}" || exit
0610: 20 31 0a 0a 09 23 20 57 6f 72 6b 20 61 72 6f 75   1...# Work arou
0620: 6e 64 20 62 75 67 20 77 68 65 72 65 20 49 74 63  nd bug where Itc
0630: 6c 20 76 33 2e 34 20 70 69 63 6b 73 20 75 70 20  l v3.4 picks up 
0640: 77 72 6f 6e 67 20 70 6c 61 74 66 6f 72 6d 20 77  wrong platform w
0650: 68 65 6e 20 63 72 6f 73 73 2d 63 6f 6d 70 69 6c  hen cross-compil
0660: 69 6e 67 0a 09 63 61 73 65 20 22 24 7b 54 43 4c  ing..case "${TCL
0670: 43 4f 4e 46 49 47 44 49 52 7d 22 20 69 6e 0a 09  CONFIGDIR}" in..
0680: 09 2a 2f 77 69 6e 29 0a 09 09 09 54 45 41 5f 50  .*/win)....TEA_P
0690: 4c 41 54 46 4f 52 4d 3d 22 77 69 6e 64 6f 77 73  LATFORM="windows
06a0: 22 0a 09 09 09 65 78 70 6f 72 74 20 54 45 41 5f  "....export TEA_
06b0: 50 4c 41 54 46 4f 52 4d 0a 09 09 09 3b 3b 0a 09  PLATFORM....;;..
06c0: 09 2a 29 0a 09 09 09 54 45 41 5f 50 4c 41 54 46  .*)....TEA_PLATF
06d0: 4f 52 4d 3d 22 75 6e 69 78 22 0a 09 09 09 65 78  ORM="unix"....ex
06e0: 70 6f 72 74 20 54 45 41 5f 50 4c 41 54 46 4f 52  port TEA_PLATFOR
06f0: 4d 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 09 73  M....;;..esac..s
0700: 65 64 20 27 73 40 54 45 41 5f 50 4c 41 54 46 4f  ed 's@TEA_PLATFO
0710: 52 4d 3d 40 74 65 73 74 20 2d 7a 20 22 24 54 45  RM=@test -z "$TE
0720: 41 5f 50 4c 41 54 46 4f 52 4d 22 20 5c 26 5c 26  A_PLATFORM" \&\&
0730: 20 26 40 27 20 63 6f 6e 66 69 67 75 72 65 20 3e   &@' configure >
0740: 20 63 6f 6e 66 69 67 75 72 65 2e 6e 65 77 20 26   configure.new &
0750: 26 20 63 61 74 20 63 6f 6e 66 69 67 75 72 65 2e  & cat configure.
0760: 6e 65 77 20 3e 20 63 6f 6e 66 69 67 75 72 65 0a  new > configure.
0770: 09 72 6d 20 2d 66 20 63 6f 6e 66 69 67 75 72 65  .rm -f configure
0780: 2e 6e 65 77 0a 0a 09 23 20 42 75 69 6c 64 0a 09  .new...# Build..
0790: 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 2e  echo "Running: .
07a0: 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d 65 6e 61  /configure --ena
07b0: 62 6c 65 2d 73 68 61 72 65 64 20 2d 2d 64 69 73  ble-shared --dis
07c0: 61 62 6c 65 2d 73 79 6d 62 6f 6c 73 20 2d 2d 70  able-symbols --p
07d0: 72 65 66 69 78 3d 5c 22 24 7b 49 4e 53 54 44 49  refix=\"${INSTDI
07e0: 52 7d 5c 22 20 2d 2d 65 78 65 63 2d 70 72 65 66  R}\" --exec-pref
07f0: 69 78 3d 5c 22 24 7b 49 4e 53 54 44 49 52 7d 5c  ix=\"${INSTDIR}\
0800: 22 20 2d 2d 77 69 74 68 2d 74 63 6c 3d 5c 22 24  " --with-tcl=\"$
0810: 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d 5c 22  {TCLCONFIGDIR}\"
0820: 20 24 7b 43 4f 4e 46 49 47 55 52 45 45 58 54 52   ${CONFIGUREEXTR
0830: 41 7d 22 0a 09 2e 2f 63 6f 6e 66 69 67 75 72 65  A}".../configure
0840: 20 2d 2d 65 6e 61 62 6c 65 2d 73 68 61 72 65 64   --enable-shared
0850: 20 2d 2d 64 69 73 61 62 6c 65 2d 73 79 6d 62 6f   --disable-symbo
0860: 6c 73 20 2d 2d 70 72 65 66 69 78 3d 22 24 7b 49  ls --prefix="${I
0870: 4e 53 54 44 49 52 7d 22 20 2d 2d 65 78 65 63 2d  NSTDIR}" --exec-
0880: 70 72 65 66 69 78 3d 22 24 7b 49 4e 53 54 44 49  prefix="${INSTDI
0890: 52 7d 22 20 2d 2d 77 69 74 68 2d 74 63 6c 3d 22  R}" --with-tcl="
08a0: 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d 22  ${TCLCONFIGDIR}"
08b0: 20 24 7b 43 4f 4e 46 49 47 55 52 45 45 58 54 52   ${CONFIGUREEXTR
08c0: 41 7d 0a 0a 09 65 63 68 6f 20 22 52 75 6e 6e 69  A}...echo "Runni
08d0: 6e 67 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65  ng: ${MAKE:-make
08e0: 7d 22 0a 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65  }"..${MAKE:-make
08f0: 7d 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 65 63  } || exit 1...ec
0900: 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 24 7b 4d  ho "Running: ${M
0910: 41 4b 45 3a 2d 6d 61 6b 65 7d 20 69 6e 73 74 61  AKE:-make} insta
0920: 6c 6c 22 0a 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b  ll"..${MAKE:-mak
0930: 65 7d 20 69 6e 73 74 61 6c 6c 0a 0a 09 6d 6b 64  e} install...mkd
0940: 69 72 20 22 24 7b 4f 55 54 44 49 52 7d 2f 6c 69  ir "${OUTDIR}/li
0950: 62 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 63 70  b" || exit 1..cp
0960: 20 2d 72 20 22 24 7b 49 4e 53 54 44 49 52 7d 2f   -r "${INSTDIR}/
0970: 6c 69 62 22 2f 69 74 63 6c 2a 20 22 24 7b 4f 55  lib"/itcl* "${OU
0980: 54 44 49 52 7d 2f 6c 69 62 2f 22 0a 0a 09 22 24  TDIR}/lib/"..."$
0990: 7b 53 54 52 49 50 3a 2d 73 74 72 69 70 7d 22 20  {STRIP:-strip}" 
09a0: 2d 67 20 22 24 7b 4f 55 54 44 49 52 7d 22 2f 6c  -g "${OUTDIR}"/l
09b0: 69 62 2f 69 74 63 6c 2a 2f 2a 2e 73 6f 20 3e 2f  ib/itcl*/*.so >/
09c0: 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f  dev/null 2>/dev/
09d0: 6e 75 6c 6c 0a 0a 09 65 78 69 74 20 30 0a 29 20  null...exit 0.) 
09e0: 7c 7c 20 65 78 69 74 20 31 0a 0a 65 78 69 74 20  || exit 1..exit 
09f0: 30 0a                                            0.